#if CP_PRAGMA_ONCE
#pragma once
#endif

#include "MCCompObj.h"
#include "Basic3DImportExport.h"
#include "MCBasicTypes.h"
#include "APITypes.h"
#include "IShParamUtilities.h"
#include "PublicUtilities.h"
#include "IShColorConversionUtilities.h"
#include "COMUtilities.h"
#include "COM3DUtilities.h"
#include "I3DShScene.h"
#include <math.h>
#include "Basic3DCOMImplementations.h"
#include "PrepAODef.h"
#include "BitField.h"
#include "I3DShFacetMesh.h"
#include "I3DShScene.h"
#include "I3DExModifier.h"
#include "ISceneSelection.h"
#include "IChangeManagement.h"
#include "PublicUtilities.h"
#include "ISceneDocument.h"
#include "MCCountedPtrArray.h"
#include "MCCountedPtr.h"
#include "IShComponent.h" // for IShParameterComponent
#include "I3DShScene.h"
#include "I3DShGroup.h"
#include "I3DShInstance.h"
#include "ISHUtilities.h"
#include "MCBasicTypes.h"
#include "I3DShCamera.h"
#include "I3DShLightSource.h"
#include "I3DShObject.h"
#include "MCColor16.h"
#include "ColorRGB214.h"
#include "COMSafeUtilities.h"
#include "I3DShTreeElement.h"
#include "I3DShJoint.h"
#include "ISceneDocument.h"
#include "BonesUtilities.h"
#include "Transforms.h"
#include "I3DShModifier.h"
#include "IExtension.h"
#include "IFigureDataComponent.h"
#include "I3DExVertexPrimitive.h"
#include "I3DShUtilities.h"
#include "COM3DUtilities.h"
#include "I3DShMasterGroup.h"
#include "I3DShPrimitiveInstance.h"
#include "I3DShObject.h"
#include "I3DShGlobalDeformerHelper.h"
#include "I3DExPrimitive.h"
#include "IShComponent.h"
#include "TBBox.h"
#include "I3DExFigurePrimitive.h"
#include "I3DExPoserSkinningAlgorithm.h"
#include "I3DExSkinningAlgorithm.h"
#include "I3dExSkinable.h"
#include "I3DSHRenderFeature.h"
#include "IMFPart.h"
#include "IMFDialogPart.h"
#include "IShPartUtilities.h"
#include "MFPartTypes.h"
#include "I3DShShader.h"
#include "BonesUtilities.h"
#include "I3dExSkinable.h"
#include "UVMaps.h"
#include "I3DImageDocument.h"
#include "IShRasterLayer.h"
#include "IShRasterLayerUtilities.h"
#include "math.h"
#include "I3DShGroup.h"
#include "I3DShTreeElement.h"
#include "I3DShModifier.h"
#include "BonesUtilities.h"
#include "COMSafeUtilities.h"
#include "I3DShShadableTree.h"
#include "IComponentChooser.h"
#include "I3DShShader.h"
#include "I3DShAttributesSet.h"
#include "I3DShAttributesSetControler.h"
#include "I3DExAttributesSetControler.h"
#include "I3DExLinkedParamController.h"
#include "BasicAttributesSetControler.h"
#include "IExParamType.h"
#include "PMapTypes.h"
#include "I3dShAnimation.h"
#include "ParamHolder.h"
#include "IComponentChooser.h"
#include <string>
#include <vector>

// define the SceneOp CLSID
extern const MCGUID CLSID_PrepAO;


// SceneOp Object :
class PrepAOCommand : public TBasicSceneCommand
{
	public :  
		PrepAOCommand();
		~PrepAOCommand();

		STANDARD_RELEASE;

		// IExDataExchanger methods :
		virtual void*	 MCCOMAPI GetExtensionDataBuffer	() { return NULL; }
		virtual int32	 MCCOMAPI GetParamsBufferSize		() const { return 0; }
		virtual MCCOMErr MCCOMAPI ExtensionDataChanged		() { return MC_S_OK; }
		virtual int16	 MCCOMAPI GetResID					() { return 150; }

		virtual void	 MCCOMAPI GetMenuCallBack(ISelfPrepareMenuCallBack** callBack);

		virtual MCCOMErr MCCOMAPI Init						(ISceneDocument* sceneDocument);
		virtual MCCOMErr MCCOMAPI Prepare					();

		virtual boolean  MCCOMAPI CanUndo					();

		virtual boolean  MCCOMAPI Do						();
		virtual boolean  MCCOMAPI Undo						();
		virtual boolean  MCCOMAPI Redo						();

	private :
		TMCCountedPtr<ISceneDocument>	fSceneDocument;
		TMCCountedPtr<I3DShScene>		fScene;

		void doShader(I3DShShader *shader);
};
